package com.jsowell.thirdparty.nanrui.util;

import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

/**
 * TODO
 *
 * @author Lemon
 * @Date 2023/10/12 13:54
 */
public class QEncodeUtil {
    public static String encrypt(String sSrc, String sKey, String datasecretiv) {
        try {
            if (sKey == null) {
                return null;
            }
            // 判断 Key 是否为 16 位
            if (sKey.length() != 16) {
                return null;
            }
            byte[] raw = sKey.getBytes("UTF-8");
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");//"算法/模式/补码方式"
            IvParameterSpec iv = new IvParameterSpec(datasecretiv.getBytes());//使用 CBC 模式，需要一个向量 iv，可增加加密算法的强度 1234567890123456
            cipher.init(Cipher.ENCRYPT_MODE, skeySpec, iv);
            byte[] encrypted = cipher.doFinal(sSrc.getBytes());
            String str = new BASE64Encoder().encode(encrypted); // 此处使用 BASE64 做转码功能，同时能起到 2 次加密的作用。
            str = str.replaceAll("\r", "");
            str = str.replaceAll("\n", "");
            return str;
        } catch (Exception ex) {
            return null;
        }
    }

    // 解密
    public static String decrypt(String sSrc, String sKey, String datasecretiv) {
        try {
            // 判断 Key 是否正确
            if (sKey == null) {
                System.out.print("Key 为空 null");
                return null;
            }
            // 判断 Key 是否为 16 位
            if (sKey.length() != 16) {
                System.out.print("Key 长度不是 16 位");
                return null;
            }
            byte[] raw = sKey.getBytes("UTF-8");
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            IvParameterSpec iv = new IvParameterSpec(datasecretiv.getBytes());
            cipher.init(Cipher.DECRYPT_MODE, skeySpec, iv);
            byte[] encrypted1 = new BASE64Decoder().decodeBuffer(sSrc);
            //先用 base64 解密
            try {
                byte[] original = cipher.doFinal(encrypted1);
                return new String(original, "UTF-8");
            } catch (Exception e) {
                e.printStackTrace();
                System.out.println(e.toString());
                return null;
            }
        } catch (Exception ex) {
            return null;
        }
    }
}
